Index: c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.hsc_cm01
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.hsc_cm01	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.hsc_cm01	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -1,332 +1,14 @@
-/*
- *  This file contains directives for the GNU linker which are specific
- *  to a hsc_cm01 board
+/**
+ * @file
  *
- *  $Id$
+ * HSC_CM01 Board.
  */
 
-OUTPUT_FORMAT("elf32-powerpc", "elf32-powerpc",
-              "elf32-powerpc")
-OUTPUT_ARCH(powerpc)
- 
-ENTRY(start)
+MEMORY {
+	RAM : ORIGIN = 0x0, LENGTH = 256M
+	ROM : ORIGIN = 0xfe000000, LENGTH = 8M
+	MPC83XX_REGS : ORIGIN = 0xe0000000, LENGTH = 256k
+	NIRVANA : ORIGIN = 0x0, LENGTH = 0
+}
 
-/*
- * Declare some sizes.
- * XXX: The assignment of ". += XyzSize;" fails in older gld's if the
- *      number used there is not constant.  If this happens to you, edit
- *      the lines marked XXX below to use a constant value.
- */
-HeapSize = DEFINED(HeapSize) ? HeapSize    : 0x6800000;  /* 104M  Heap */
-StackSize = DEFINED(StackSize) ? StackSize :   0x80000;  /* 512 kB   */
-WorkSpaceSize = DEFINED(WorkSpaceSize) ? WorkSpaceSize : 0x80000; /* 512k */
-RamDiskSize = DEFINED(RamDiskSize) ? RamDiskSize : 0x80000; /* 512 ram disk */
-
-/* 
- * optionally reserve additional space 
- */
-TopRamReserved = DEFINED(TopRamReserved) ? TopRamReserved : 0;
- 
-MEMORY
-	{
-	ram          : org = 0x0,        l = 256M
-	mpc83xx_regs : org = 0xE0000000, l = 256k
-	}
-
-
-SECTIONS
-{
-
-    .mpc83xx_regs (NOLOAD) :
-    { 
-    IMMRBAR = .;
-    mpc83xx_regs*(.text)
-    mpc83xx_regs*(.data)
-    mpc83xx_regs*(.bss)
-    mpc83xx_regs*(*COM*)
-    } > mpc83xx_regs
-
-   .resconf 0x000 :
-    {
-    *(.resconf)
-    } > ram
-
-   .vectors 0x100 :
-    {
-    *(.vectors)
-    }   
-    > ram
-
-    /* 
-     * The stack will live in this area - between the vectors and
-     * the text section.
-     */
-	
-    .text 0x10000:
-    {
-    _textbase = .;
-
-
-    text.start = .;
-
-    /* Entry point is the .entry section */
-    *(.entry)
-    *(.entry2)
-
-    /* Actual Code */
-    *(.text*)
-
-    *(.rodata*)
-    *(.rodata1)
-
-
-    /*
-     * Special FreeBSD sysctl sections.
-     */
-    . = ALIGN (16);
-    __start_set_sysctl_set = .;
-    *(set_sysctl_*);
-    __stop_set_sysctl_set = ABSOLUTE(.);
-    *(set_domain_*);
-    *(set_pseudo_*);
-
-    /* C++ constructors/destructors */
-    *(.gnu.linkonce.t*)
-
-    /*  Initialization and finalization code.
-     *
-     *  Various files can provide initialization and finalization functions.
-     *  The bodies of these functions are in .init and .fini sections. We
-     *  accumulate the bodies here, and prepend function prologues from
-     *  ecrti.o and function epilogues from ecrtn.o. ecrti.o must be linked
-     *  first; ecrtn.o must be linked last. Because these are wildcards, it
-     *  doesn't matter if the user does not actually link against ecrti.o and
-     *  ecrtn.o; the linker won't look for a file to match a wildcard.  The
-     *  wildcard also means that it doesn't matter which directory ecrti.o
-     *  and ecrtn.o are in. 
-     */
-    PROVIDE (_init = .);
-    *ecrti.o(.init)
-    *(.init)
-    *ecrtn.o(.init)
-    
-    PROVIDE (_fini = .);
-    *ecrti.o(.fini)
-    *(.fini)
-    *ecrtn.o(.init)
-
-    /* 
-     *  C++ constructors and destructors for static objects.
-     *  PowerPC EABI does not use crtstuff yet, so we build "old-style"
-     *  constructor and destructor lists that begin with the list lenght
-     *  end terminate with a NULL entry.
-     */
-     
-    PROVIDE (__CTOR_LIST__ = .);	     
-    *crtbegin.o(.ctors)
-    *(.ctors)
-    *crtend.o(.ctors)
-    LONG(0)
-    PROVIDE (__CTOR_END__ = .);
-	
-    PROVIDE (__DTOR_LIST__ = .);
-    *crtbegin.o(.dtors)
-    *(.dtors)
-    *crtend.o(.dtors)
-    LONG(0)
-    PROVIDE (__DTOR_END__ = .);
-	
-    /* Exception frame info */
-    *(.eh_frame)
-
-    /* Miscellaneous read-only data */
-    _rodata_start = . ;
-    *(.gnu.linkonce.r*)
-    *(.lit)
-    *(.shdata)
-    *(.rodata)
-    *(.rodata1)
-    *(.descriptors)
-    *(rom_ver)
-    _erodata = .;
-
-    PROVIDE (__EXCEPT_START__ = .);
-    *(.gcc_except_table*)
-    PROVIDE (__EXCEPT_END__ = .);
-    __GOT_START__ = .;
-    s.got = .;
-    *(.got.plt) 
-    *(.got)
-    *(.got1)
-    PROVIDE (__GOT2_START__ = .);
-    PROVIDE (_GOT2_START_ = .);
-    *(.got2)
-    PROVIDE (__GOT2_END__ = .);
-    PROVIDE (_GOT2_END_ = .);
-    
-    PROVIDE (__FIXUP_START__ = .);
-    PROVIDE (_FIXUP_START_ = .);
-    *(.fixup)
-    PROVIDE (_FIXUP_END_ = .);
-    PROVIDE (__FIXUP_END__ = .);
-    
-
-    /* Various possible names for the end of the .text section */
-    etext = ALIGN(0x10);
-    _etext = .;
-    _endtext = .;
-    text.end = .;
-    PROVIDE (etext = .);
-    PROVIDE (__etext = .);
- 
-    } > ram
-
-  .jcr : { KEEP (*(.jcr)) } > ram
-
-    .rel.dyn : {
-      *(.rel.init)
-      *(.rel.text .rel.text.* .rel.gnu.linkonce.t.*)
-      *(.rel.fini)
-      *(.rel.rodata .rel.rodata.* .rel.gnu.linkonce.r.*)
-      *(.rel.data.rel.ro* .rel.gnu.linkonce.d.rel.ro.*)
-      *(.rel.data .rel.data.* .rel.gnu.linkonce.d.*)
-      *(.rel.tdata .rel.tdata.* .rel.gnu.linkonce.td.*)
-      *(.rel.tbss .rel.tbss.* .rel.gnu.linkonce.tb.*)
-      *(.rel.ctors)
-      *(.rel.dtors)
-      *(.rel.got)
-      *(.rel.sdata .rel.sdata.* .rel.gnu.linkonce.s.*)
-      *(.rel.sbss .rel.sbss.* .rel.gnu.linkonce.sb.*)
-      *(.rel.sdata2 .rel.sdata2.* .rel.gnu.linkonce.s2.*)
-      *(.rel.sbss2 .rel.sbss2.* .rel.gnu.linkonce.sb2.*)
-      *(.rel.bss .rel.bss.* .rel.gnu.linkonce.b.*)
-    } >ram
-    .rela.dyn : {
-      *(.rela.init)
-      *(.rela.text .rela.text.* .rela.gnu.linkonce.t.*)
-      *(.rela.fini)
-      *(.rela.rodata .rela.rodata.* .rela.gnu.linkonce.r.*)
-      *(.rela.data .rela.data.* .rela.gnu.linkonce.d.*)
-      *(.rela.tdata .rela.tdata.* .rela.gnu.linkonce.td.*)
-      *(.rela.tbss .rela.tbss.* .rela.gnu.linkonce.tb.*)
-      *(.rela.ctors)
-      *(.rela.dtors)
-      *(.rela.got)
-      *(.rela.got1)
-      *(.rela.got2)
-      *(.rela.sdata .rela.sdata.* .rela.gnu.linkonce.s.*)
-      *(.rela.sbss .rela.sbss.* .rela.gnu.linkonce.sb.*)
-      *(.rela.sdata2 .rela.sdata2.* .rela.gnu.linkonce.s2.*)
-      *(.rela.sbss2 .rela.sbss2.* .rela.gnu.linkonce.sb2.*)
-      *(.rela.bss .rela.bss.* .rela.gnu.linkonce.b.*)
-    } >ram
-
-    PROVIDE (__SDATA2_START__ = .);
-  .sdata2   	  : { *(.sdata2) *(.gnu.linkonce.s2.*)	} >ram
-  .sbss2   	  : { *(.sbss2) *(.gnu.linkonce.sb2.*)	} >ram
-    PROVIDE (__SBSS2_END__ = .);
-	
-    .sbss2   	  : { *(.sbss2) 	} >ram
-    PROVIDE (__SBSS2_END__ = .);
-	
-    /* R/W Data */
-    .data ( . ) :
-    {
-      . = ALIGN (4);
-
-      data.start = .;
-
-      *(.data)
-      *(.data1)
-      *(.data.* .gnu.linkonce.d.*)
-      PROVIDE (__SDATA_START__ = .);
-      *(.sdata*)
-      *(.gnu.linkonce.s.*)
-      data.end = .;
-    } > ram
-
-    __SBSS_START__ = .;
-    .bss :
-    {
-      bss.start = .;
-      *(.bss .bss* .gnu.linkonce.b*)
-      *(.sbss*) *(COMMON)
-      . = ALIGN(4);
-      bss.end = .;
-    } > ram
-    __SBSS_END__ = .;
-
-    PROVIDE(_bss_start   = ADDR(.bss));
-    PROVIDE(_bss_size    = SIZEOF(.bss));
-    PROVIDE(_data_start  = ADDR(.data));
-    PROVIDE(_data_size   = SIZEOF(.data));
-    PROVIDE(_text_start  = ADDR(.text));
-    PROVIDE(_text_size   = SIZEOF(.text));
-    PROVIDE(_end = data.end);
-
-    .gzipmalloc : {
-	. = ALIGN (16);
-        _startmalloc = .;
-     } >ram
-          	
-
-    /*
-     * Interrupt stack setup
-     */
-    IntrStack_start = ALIGN(0x10);
-    . += 0x4000;
-    intrStack = .;
-    PROVIDE(intrStackPtr = intrStack);
-
-
-
-
-    _WorkspaceBase = .;
-    __WorkspaceBase = .;
-    . += WorkSpaceSize;
-
-    _RamDiskBase = .;
-    __RamDiskBase = .;
-    . += RamDiskSize;
-    _RamDiskEnd  = .;
-    __RamDiskEnd = .;
-    PROVIDE( _RamDiskSize = _RamDiskEnd - _RamDiskBase );
-
-    _HeapStart = .;
-    __HeapStart = .;
-    . += HeapSize;
-    _HeapEnd = .;
-    __HeapEnd = .;
-
-    clear_end = .;
-
-    /* Sections for compressed .text and .data         */
-    /* after the .datarom section is an int specifying */
-    /* the length of the following compressed image    */
-    /* Executes once then could get overwritten        */
-    .textrom 0x100000 :
-    {
-    	*(.textrom)
-    	_endloader = .;
-    } > ram
-
-    .datarom :
-    {
-    	_dr_start = .;
-    	*(.datarom)
-    	_dr_end = .;
-    } > ram
-    dr_len = _dr_end - _dr_start;
-
-
-    .line 0 : { *(.line) }
-    .debug 0 : { *(.debug) }
-    .debug_sfnames 0 : { *(.debug_sfnames) }
-    .debug_srcinfo 0 : { *(.debug_srcinfo) }
-    .debug_pubnames 0 : { *(.debug_pubnames) }
-    .debug_aranges 0 : { *(.debug_aranges) }
-    .debug_aregion 0 : { *(.debug_aregion) }
-    .debug_macinfo 0 : { *(.debug_macinfo) }
-    .stab 0 : { *(.stab) }
-    .stabstr 0 : { *(.stabstr) }
-}
+INCLUDE linkcmds.base
Index: c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.mpc8313erdb
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.mpc8313erdb	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.mpc8313erdb	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,14 @@
+/**
+ * @file
+ *
+ * MPC8313E Reference Design Board.
+ */
+
+MEMORY {
+	RAM : ORIGIN = 0x0, LENGTH = 128M
+	ROM : ORIGIN = 0xfe000000, LENGTH = 8M
+	MPC83XX_REGS : ORIGIN = 0xe0000000, LENGTH = 256k
+	NIRVANA : ORIGIN = 0x0, LENGTH = 0
+}
+
+INCLUDE linkcmds.base
Index: c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.mpc8349eamds
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.mpc8349eamds	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.mpc8349eamds	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -1,332 +1,14 @@
-/*
- *  This file contains directives for the GNU linker which are specific
- *  to a gen8349eamds board
+/**
+ * @file
  *
- *  $Id$
+ * MPC8349EAMDS Board.
  */
 
-OUTPUT_FORMAT("elf32-powerpc", "elf32-powerpc",
-              "elf32-powerpc")
-OUTPUT_ARCH(powerpc)
- 
-ENTRY(start)
+MEMORY {
+	RAM : ORIGIN = 0x0, LENGTH = 256M
+	ROM : ORIGIN = 0xfe000000, LENGTH = 8M
+	MPC83XX_REGS : ORIGIN = 0xe0000000, LENGTH = 256k
+	NIRVANA : ORIGIN = 0x0, LENGTH = 0
+}
 
-/*
- * Declare some sizes.
- * XXX: The assignment of ". += XyzSize;" fails in older gld's if the
- *      number used there is not constant.  If this happens to you, edit
- *      the lines marked XXX below to use a constant value.
- */
-HeapSize = DEFINED(HeapSize) ? HeapSize    : 0x6800000;  /* 104M  Heap */
-StackSize = DEFINED(StackSize) ? StackSize :   0x80000;  /* 512 kB   */
-WorkSpaceSize = DEFINED(WorkSpaceSize) ? WorkSpaceSize : 0x80000; /* 512k */
-RamDiskSize = DEFINED(RamDiskSize) ? RamDiskSize : 0x80000; /* 512 ram disk */
-
-/* 
- * optionally reserve additional space 
- */
-TopRamReserved = DEFINED(TopRamReserved) ? TopRamReserved : 0;
- 
-MEMORY
-	{
-	ram          : org = 0x0,        l = 256M
-	mpc83xx_regs : org = 0xE0000000, l = 256k
-	}
-
-
-SECTIONS
-{
-
-    mpc83xx_regs (NOLOAD) :
-    { 
-    IMMRBAR = .;
-    mpc83xx_regs*(.text)
-    mpc83xx_regs*(.data)
-    mpc83xx_regs*(.bss)
-    mpc83xx_regs*(*COM*)
-    } > mpc83xx_regs
-
-   .resconf 0x000 :
-    {
-    *(.resconf)
-    } > ram
-
-   .vectors 0x100 :
-    {
-    *(.vectors)
-    }   
-    > ram
-
-    /* 
-     * The stack will live in this area - between the vectors and
-     * the text section.
-     */
-	
-    .text 0x10000:
-    {
-    _textbase = .;
-
-
-    text.start = .;
-
-    /* Entry point is the .entry section */
-    *(.entry)
-    *(.entry2)
-
-    /* Actual Code */
-    *(.text*)
-
-    *(.rodata*)
-    *(.rodata1)
-
-
-    /*
-     * Special FreeBSD sysctl sections.
-     */
-    . = ALIGN (16);
-    __start_set_sysctl_set = .;
-    *(set_sysctl_*);
-    __stop_set_sysctl_set = ABSOLUTE(.);
-    *(set_domain_*);
-    *(set_pseudo_*);
-
-    /* C++ constructors/destructors */
-    *(.gnu.linkonce.t*)
-
-    /*  Initialization and finalization code.
-     *
-     *  Various files can provide initialization and finalization functions.
-     *  The bodies of these functions are in .init and .fini sections. We
-     *  accumulate the bodies here, and prepend function prologues from
-     *  ecrti.o and function epilogues from ecrtn.o. ecrti.o must be linked
-     *  first; ecrtn.o must be linked last. Because these are wildcards, it
-     *  doesn't matter if the user does not actually link against ecrti.o and
-     *  ecrtn.o; the linker won't look for a file to match a wildcard.  The
-     *  wildcard also means that it doesn't matter which directory ecrti.o
-     *  and ecrtn.o are in. 
-     */
-    PROVIDE (_init = .);
-    *ecrti.o(.init)
-    *(.init)
-    *ecrtn.o(.init)
-    
-    PROVIDE (_fini = .);
-    *ecrti.o(.fini)
-    *(.fini)
-    *ecrtn.o(.init)
-
-    /* 
-     *  C++ constructors and destructors for static objects.
-     *  PowerPC EABI does not use crtstuff yet, so we build "old-style"
-     *  constructor and destructor lists that begin with the list lenght
-     *  end terminate with a NULL entry.
-     */
-     
-    PROVIDE (__CTOR_LIST__ = .);	     
-    *crtbegin.o(.ctors)
-    *(.ctors)
-    *crtend.o(.ctors)
-    LONG(0)
-    PROVIDE (__CTOR_END__ = .);
-	
-    PROVIDE (__DTOR_LIST__ = .);
-    *crtbegin.o(.dtors)
-    *(.dtors)
-    *crtend.o(.dtors)
-    LONG(0)
-    PROVIDE (__DTOR_END__ = .);
-	
-    /* Exception frame info */
-    *(.eh_frame)
-
-    /* Miscellaneous read-only data */
-    _rodata_start = . ;
-    *(.gnu.linkonce.r*)
-    *(.lit)
-    *(.shdata)
-    *(.rodata)
-    *(.rodata1)
-    *(.descriptors)
-    *(rom_ver)
-    _erodata = .;
-
-    PROVIDE (__EXCEPT_START__ = .);
-    *(.gcc_except_table*)
-    PROVIDE (__EXCEPT_END__ = .);
-    __GOT_START__ = .;
-    s.got = .;
-    *(.got.plt) 
-    *(.got)
-    *(.got1)
-    PROVIDE (__GOT2_START__ = .);
-    PROVIDE (_GOT2_START_ = .);
-    *(.got2)
-    PROVIDE (__GOT2_END__ = .);
-    PROVIDE (_GOT2_END_ = .);
-    
-    PROVIDE (__FIXUP_START__ = .);
-    PROVIDE (_FIXUP_START_ = .);
-    *(.fixup)
-    PROVIDE (_FIXUP_END_ = .);
-    PROVIDE (__FIXUP_END__ = .);
-    
-
-    /* Various possible names for the end of the .text section */
-    etext = ALIGN(0x10);
-    _etext = .;
-    _endtext = .;
-    text.end = .;
-    PROVIDE (etext = .);
-    PROVIDE (__etext = .);
- 
-    } > ram
-
-  .jcr : { KEEP (*(.jcr)) } > ram
-
-    .rel.dyn : {
-      *(.rel.init)
-      *(.rel.text .rel.text.* .rel.gnu.linkonce.t.*)
-      *(.rel.fini)
-      *(.rel.rodata .rel.rodata.* .rel.gnu.linkonce.r.*)
-      *(.rel.data.rel.ro* .rel.gnu.linkonce.d.rel.ro.*)
-      *(.rel.data .rel.data.* .rel.gnu.linkonce.d.*)
-      *(.rel.tdata .rel.tdata.* .rel.gnu.linkonce.td.*)
-      *(.rel.tbss .rel.tbss.* .rel.gnu.linkonce.tb.*)
-      *(.rel.ctors)
-      *(.rel.dtors)
-      *(.rel.got)
-      *(.rel.sdata .rel.sdata.* .rel.gnu.linkonce.s.*)
-      *(.rel.sbss .rel.sbss.* .rel.gnu.linkonce.sb.*)
-      *(.rel.sdata2 .rel.sdata2.* .rel.gnu.linkonce.s2.*)
-      *(.rel.sbss2 .rel.sbss2.* .rel.gnu.linkonce.sb2.*)
-      *(.rel.bss .rel.bss.* .rel.gnu.linkonce.b.*)
-    } >ram
-    .rela.dyn : {
-      *(.rela.init)
-      *(.rela.text .rela.text.* .rela.gnu.linkonce.t.*)
-      *(.rela.fini)
-      *(.rela.rodata .rela.rodata.* .rela.gnu.linkonce.r.*)
-      *(.rela.data .rela.data.* .rela.gnu.linkonce.d.*)
-      *(.rela.tdata .rela.tdata.* .rela.gnu.linkonce.td.*)
-      *(.rela.tbss .rela.tbss.* .rela.gnu.linkonce.tb.*)
-      *(.rela.ctors)
-      *(.rela.dtors)
-      *(.rela.got)
-      *(.rela.got1)
-      *(.rela.got2)
-      *(.rela.sdata .rela.sdata.* .rela.gnu.linkonce.s.*)
-      *(.rela.sbss .rela.sbss.* .rela.gnu.linkonce.sb.*)
-      *(.rela.sdata2 .rela.sdata2.* .rela.gnu.linkonce.s2.*)
-      *(.rela.sbss2 .rela.sbss2.* .rela.gnu.linkonce.sb2.*)
-      *(.rela.bss .rela.bss.* .rela.gnu.linkonce.b.*)
-    } >ram
-
-    PROVIDE (__SDATA2_START__ = .);
-  .sdata2   	  : { *(.sdata2) *(.gnu.linkonce.s2.*)	} >ram
-  .sbss2   	  : { *(.sbss2) *(.gnu.linkonce.sb2.*)	} >ram
-    PROVIDE (__SBSS2_END__ = .);
-	
-    .sbss2   	  : { *(.sbss2) 	} >ram
-    PROVIDE (__SBSS2_END__ = .);
-	
-    /* R/W Data */
-    .data ( . ) :
-    {
-      . = ALIGN (4);
-
-      data.start = .;
-
-      *(.data)
-      *(.data1)
-      *(.data.* .gnu.linkonce.d.*)
-      PROVIDE (__SDATA_START__ = .);
-      *(.sdata*)
-      *(.gnu.linkonce.s.*)
-      data.end = .;
-    } > ram
-
-    __SBSS_START__ = .;
-    .bss :
-    {
-      bss.start = .;
-      *(.bss .bss* .gnu.linkonce.b*)
-      *(.sbss*) *(COMMON)
-      . = ALIGN(4);
-      bss.end = .;
-    } > ram
-    __SBSS_END__ = .;
-
-    PROVIDE(_bss_start   = ADDR(.bss));
-    PROVIDE(_bss_size    = SIZEOF(.bss));
-    PROVIDE(_data_start  = ADDR(.data));
-    PROVIDE(_data_size   = SIZEOF(.data));
-    PROVIDE(_text_start  = ADDR(.text));
-    PROVIDE(_text_size   = SIZEOF(.text));
-    PROVIDE(_end = data.end);
-
-    .gzipmalloc : {
-	. = ALIGN (16);
-        _startmalloc = .;
-     } >ram
-          	
-
-    /*
-     * Interrupt stack setup
-     */
-    IntrStack_start = ALIGN(0x10);
-    . += 0x4000;
-    intrStack = .;
-    PROVIDE(intrStackPtr = intrStack);
-
-
-
-
-    _WorkspaceBase = .;
-    __WorkspaceBase = .;
-    . += WorkSpaceSize;
-
-    _RamDiskBase = .;
-    __RamDiskBase = .;
-    . += RamDiskSize;
-    _RamDiskEnd  = .;
-    __RamDiskEnd = .;
-    PROVIDE( _RamDiskSize = _RamDiskEnd - _RamDiskBase );
-
-    _HeapStart = .;
-    __HeapStart = .;
-    . += HeapSize;
-    _HeapEnd = .;
-    __HeapEnd = .;
-
-    clear_end = .;
-
-    /* Sections for compressed .text and .data         */
-    /* after the .datarom section is an int specifying */
-    /* the length of the following compressed image    */
-    /* Executes once then could get overwritten        */
-    .textrom 0x100000 :
-    {
-    	*(.textrom)
-    	_endloader = .;
-    } > ram
-
-    .datarom :
-    {
-    	_dr_start = .;
-    	*(.datarom)
-    	_dr_end = .;
-    } > ram
-    dr_len = _dr_end - _dr_start;
-
-
-    .line 0 : { *(.line) }
-    .debug 0 : { *(.debug) }
-    .debug_sfnames 0 : { *(.debug_sfnames) }
-    .debug_srcinfo 0 : { *(.debug_srcinfo) }
-    .debug_pubnames 0 : { *(.debug_pubnames) }
-    .debug_aranges 0 : { *(.debug_aranges) }
-    .debug_aregion 0 : { *(.debug_aregion) }
-    .debug_macinfo 0 : { *(.debug_macinfo) }
-    .stab 0 : { *(.stab) }
-    .stabstr 0 : { *(.stabstr) }
-}
+INCLUDE linkcmds.base
Index: c/src/lib/libbsp/powerpc/haleakala/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/haleakala/ChangeLog	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/haleakala/ChangeLog	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -1,2 +1,9 @@
+2008-07-14	Thomas Doerfler <thomas.doerfler@embedded-brains.de>
+
+	* irq/irq.c: adapted DCR access syntax
+	
+	* startup/linkcmds, startup/bspstartup.c, Makefile.am: 
+	adapted to exception support code
+
 2008-07-14	Thomas Doerfler <thomas.doerfler@embedded-brains.de>
 
Index: c/src/lib/libbsp/powerpc/haleakala/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/haleakala/Makefile.am	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/haleakala/Makefile.am	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -57,5 +57,5 @@
 	../../../libcpu/@RTEMS_CPU@/@exceptions@/bspsupport/irq_supp.h \
 	../../../libcpu/@RTEMS_CPU@/@exceptions@/bspsupport/ppc_exc_bspsupp.h
-	
+
 noinst_PROGRAMS += irq.rel
 irq_rel_SOURCES = irq/irq_init.c irq/irq.c
@@ -64,11 +64,11 @@
 
 
-if HAS_NETWORKING
-network_CPPFLAGS = -D__INSIDE_RTEMS_BSD_TCPIP_STACK__
-noinst_PROGRAMS += network.rel
-network_rel_SOURCES = network/network.c
-network_rel_CPPFLAGS = $(AM_CPPFLAGS) $(network_CPPFLAGS)
-network_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-endif
+## if HAS_NETWORKING
+## network_CPPFLAGS = -D__INSIDE_RTEMS_BSD_TCPIP_STACK__
+## noinst_PROGRAMS += network.rel
+## network_rel_SOURCES = network/network.c
+## network_rel_CPPFLAGS = $(AM_CPPFLAGS) $(network_CPPFLAGS)
+## network_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+## endif
 
 
@@ -78,15 +78,15 @@
 libbsp_a_LIBADD = startup.rel dlentry.rel console.rel irq.rel
 
-if HAS_NETWORKING
-libbsp_a_LIBADD += network.rel
-endif
+## if HAS_NETWORKING
+## libbsp_a_LIBADD += network.rel
+## endif
 
 libbsp_a_LIBADD += ../../../libcpu/@RTEMS_CPU@/@exceptions@/rtems-cpu.rel \
-    ../../../libcpu/@RTEMS_CPU@/@exceptions@/raw_exception.rel \
- 	../../../libcpu/@RTEMS_CPU@/@exceptions@/exc_bspsupport.rel \
+	../../../libcpu/@RTEMS_CPU@/@exceptions@/raw_exception.rel \
+	../../../libcpu/@RTEMS_CPU@/@exceptions@/exc_bspsupport.rel \
 	../../../libcpu/@RTEMS_CPU@/@exceptions@/irq_bspsupport.rel \
-    ../../../libcpu/@RTEMS_CPU@/shared/cpuIdent.rel \
+	../../../libcpu/@RTEMS_CPU@/shared/cpuIdent.rel \
 	../../../libcpu/@RTEMS_CPU@/ppc403/clock.rel \
-    ../../../libcpu/@RTEMS_CPU@/ppc403/timer.rel 
+	../../../libcpu/@RTEMS_CPU@/ppc403/timer.rel 
 
 
Index: c/src/lib/libbsp/powerpc/haleakala/irq/irq.c
===================================================================
--- c/src/lib/libbsp/powerpc/haleakala/irq/irq.c	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/haleakala/irq/irq.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -70,7 +70,10 @@
 /* Write the gEnabledInts state masked by gIntInhibited to the hardware */
 {
-	mtdcr(UIC0_ER, gEnabledInts[0] & ~gIntInhibited[0]);
-	mtdcr(UIC1_ER, gEnabledInts[1] & ~gIntInhibited[1]);
-	mtdcr(UIC2_ER, gEnabledInts[2] & ~gIntInhibited[2]);
+	PPC_SET_DEVICE_CONTROL_REGISTER(UIC0_ER, 
+					gEnabledInts[0] & ~gIntInhibited[0]);
+	PPC_SET_DEVICE_CONTROL_REGISTER(UIC1_ER, 
+					gEnabledInts[1] & ~gIntInhibited[1]);
+	PPC_SET_DEVICE_CONTROL_REGISTER(UIC2_ER, 
+					gEnabledInts[2] & ~gIntInhibited[2]);
 }
 
@@ -113,24 +116,42 @@
 		gIntInhibited[i] = 0;
 		
-	mtdcr (UIC2_ER, 0x00000000);	/* disable all interrupts */
-	mtdcr (UIC2_CR, 0x00000000);	/* Set Critical / Non Critical interrupts */
-	mtdcr (UIC2_PR, 0xf7ffffff);	/* Set Interrupt Polarities */
-	mtdcr (UIC2_TR, 0x01e1fff8);	/* Set Interrupt Trigger Levels */
-	mtdcr (UIC2_VR, 0x00000001);	/* Set Vect base=0,INT31 Highest priority */
-	mtdcr (UIC2_SR, 0xffffffff);	/* clear all interrupts */
-
-	mtdcr (UIC1_ER, 0x00000000);	/* disable all interrupts */
-	mtdcr (UIC1_CR, 0x00000000);	/* Set Critical / Non Critical interrupts */
-	mtdcr (UIC1_PR, 0xfffac785);	/* Set Interrupt Polarities */
-	mtdcr (UIC1_TR, 0x001d0040);	/* Set Interrupt Trigger Levels */
-	mtdcr (UIC1_VR, 0x00000001);	/* Set Vect base=0,INT31 Highest priority */
-	mtdcr (UIC1_SR, 0xffffffff);	/* clear all interrupts */
-
-	mtdcr (UIC0_ER, 0x0000000a);	/* Disable all interrupts except cascade UIC0 and UIC1 */
-	mtdcr (UIC0_CR, 0x00000000);	/* Set Critical / Non Critical interrupts */
-	mtdcr (UIC0_PR, 0xffbfefef);	/* Set Interrupt Polarities */
-	mtdcr (UIC0_TR, 0x00007000);	/* Set Interrupt Trigger Levels */
-	mtdcr (UIC0_VR, 0x00000001);	/* Set Vect base=0,INT31 Highest priority */
-	mtdcr (UIC0_SR, 0xffffffff);	/* clear all interrupts */
+	/* disable all interrupts */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC2_ER, 0x00000000);	
+	/* Set Critical / Non Critical interrupts */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC2_CR, 0x00000000);
+	/* Set Interrupt Polarities */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC2_PR, 0xf7ffffff);
+	/* Set Interrupt Trigger Levels */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC2_TR, 0x01e1fff8);
+	/* Set Vect base=0,INT31 Highest priority */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC2_VR, 0x00000001);
+	/* clear all interrupts */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC2_SR, 0xffffffff);
+
+	/* disable all interrupts */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC1_ER, 0x00000000);
+	/* Set Critical / Non Critical interrupts */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC1_CR, 0x00000000);
+	/* Set Interrupt Polarities */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC1_PR, 0xfffac785);
+	/* Set Interrupt Trigger Levels */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC1_TR, 0x001d0040);
+	/* Set Vect base=0,INT31 Highest priority */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC1_VR, 0x00000001);
+	/* clear all interrupts */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC1_SR, 0xffffffff);
+
+	/* Disable all interrupts except cascade UIC0 and UIC1 */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC0_ER, 0x0000000a);
+	/* Set Critical / Non Critical interrupts */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC0_CR, 0x00000000);
+	/* Set Interrupt Polarities */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC0_PR, 0xffbfefef);
+	/* Set Interrupt Trigger Levels */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC0_TR, 0x00007000);
+	/* Set Vect base=0,INT31 Highest priority */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC0_VR, 0x00000001);
+	/* clear all interrupts */
+	PPC_SET_DEVICE_CONTROL_REGISTER (UIC0_SR, 0xffffffff);
 	
 	return 1;
@@ -154,7 +175,7 @@
 		   Likely to be only one, but we need to handle more than one,
 		   OR the flags into gIntInhibited */
-		active[0] = mfdcr(UIC0_MSR);
-		active[1] = mfdcr(UIC1_MSR);
-		active[2] = mfdcr(UIC2_MSR);
+		active[0] = PPC_DEVICE_CONTROL_REGISTER(UIC0_MSR);
+		active[1] = PPC_DEVICE_CONTROL_REGISTER(UIC1_MSR);
+		active[2] = PPC_DEVICE_CONTROL_REGISTER(UIC2_MSR);
 		gIntInhibited[0] |= active[0];
 		gIntInhibited[1] |= active[1];
@@ -181,7 +202,13 @@
 			bmask = 0x80000000 >> bit;
 			switch (index) {
-				case 0: mtdcr(UIC0_SR, bmask); break;
-				case 1: mtdcr(UIC1_SR, bmask); break;
-				case 2: mtdcr(UIC2_SR, bmask); break;
+			case 0: 
+			  PPC_SET_DEVICE_CONTROL_REGISTER(UIC0_SR, bmask);
+			  break;
+			case 1: 
+			  PPC_SET_DEVICE_CONTROL_REGISTER(UIC1_SR, bmask);
+			  break;
+			case 2: 
+			  PPC_SET_DEVICE_CONTROL_REGISTER(UIC2_SR, bmask);
+			  break;
 			}
 			
Index: c/src/lib/libbsp/powerpc/haleakala/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/powerpc/haleakala/startup/bspstart.c	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/haleakala/startup/bspstart.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -69,11 +69,8 @@
 #include <rtems/bspIo.h>
 #include <libcpu/cpuIdent.h>
-#include <libcpu/spr.h>
 #include <rtems/powerpc/powerpc.h>
+#include <bsp/ppc_exc_bspsupp.h>
 #include <ppc4xx/ppc405gp.h>
 #include <ppc4xx/ppc405ex.h>
-
-SPR_RW(SPRG0)
-SPR_RW(SPRG1)
 
 #include <stdio.h>
@@ -233,6 +230,6 @@
 void bsp_start( void )
 {
-	extern unsigned long *intrStackPtr;
-	register unsigned char* intrStack;
+	LINKER_SYMBOL(intrStack_start);
+	LINKER_SYMBOL(intrStack_size);
 	ppc_cpu_id_t myCpu;
 	ppc_cpu_revision_t myCpuRevision;
@@ -263,14 +260,10 @@
 	
 	/*
-	* Initialize some SPRG registers related to irq handling
-	*/
-
-	intrStack = (((unsigned char*)&intrStackPtr) - PPC_MINIMUM_STACK_FRAME_SIZE);
-	_write_SPRG1((unsigned int)intrStack);
-	/* signal them that we have fixed PR288 - eventually, this should go away */
-	/*
 	* Initialize default raw exception handlers. 
 	*/
-	initialize_exceptions();
+	ppc_exc_initialize(
+		PPC_INTERRUPT_DISABLE_MASK_DEFAULT,
+			   (uint32_t) intrStack_start,
+			   (uint32_t) intrStack_size);
 
 	/*
Index: c/src/lib/libbsp/powerpc/haleakala/startup/linkcmds
===================================================================
--- c/src/lib/libbsp/powerpc/haleakala/startup/linkcmds	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/haleakala/startup/linkcmds	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -230,4 +230,6 @@
     intrStack = .;
     PROVIDE(intrStackPtr = intrStack);
+    PROVIDE(intrStack_start = IntrStack_start);
+    PROVIDE(intrStack_size = kIntrStackSize);
 
  	/* Main stack: align to a cache-line boundary */
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/ChangeLog	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/ChangeLog	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,7 @@
+2008-07-14     Sebastian Huber <sebastian.huber@embedded-brains.de>
+
+	* bsp_specs, configure.ac, include/bsp.h, include/irq-config.h,
+	include/mpc55xxevb.h, Makefile.am, network/network.c, preinstall.am,
+	README, startup/bspclean.c, startup/bspstart.c, startup/linkcmds,
+	startup/linkcmds.memory, startup/sd-card-init.c, startup/start.S,
+	tests/tests.c: New files.
